'
'        Summary: event.h
'        *The header file for the microkernel event handling routines*
'
'        Author:
'            Marcel Sondaar
'
'        License:
'            Public Domain
'
#ifndef _MOS_EVENT_H_
#define _MOS_EVENT_H_

Type MOS_EVENTHANDLER
    callback As Function CDecl (ByVal custom As Byte Ptr, ByVal sender As Integer, ByVal length as Integer, ByVal buffer As Byte Ptr) As Integer
    customdata As Byte Ptr
End Type

Type MOS_EVENTHANDLER_TREE
    max_message_sub As Unsigned Integer
    handles As MOS_EVENTHANDLER Ptr
End Type

Type MOS_EVENTHANDLER_ROOT
    max_roots As Unsigned Integer
    sys_trees As MOS_EVENTHANDLER_TREE Ptr
    user_tree As MOS_EVENTHANDLER_TREE Ptr
    errorhandler As Function CDecl (ByVal sender As Integer, ByVal length as Integer, ByVal buffer As Byte Ptr) As Integer
End Type

Extern mos_eventhandles Alias "mos_eventhandles" As MOS_EVENTHANDLER_ROOT Ptr

Declare Function mos_eventloop CDecl Alias "mos_eventloop" () As Integer
Declare Function mos_eventloop_prime CDecl Alias "mos_eventloop_prime" (ByVal alternativeroot As MOS_EVENTHANDLER_ROOT Ptr) As Integer

Extern eventdata_alloc Alias "eventdata_alloc" As Function (ByVal Size As Integer) As Byte Ptr
Extern eventdata_free Alias "eventdata_free" As Sub (ByVal pointer As Byte Ptr)

'extern void * (*eventdata_alloc)(size_t);
'extern void (*eventdata_free)(void *);

#endif
