' Summary: glbuffer.bi
' Defines an interface for output maps
'
' Author:
'     Marcel Sondaar
'
' License:
'     <Public Domain>
'

#ifndef _GLBUFFER_BI_
#define _GLBUFFER_BI_

Type GLbuffer

    base As Unsigned Byte Ptr
    width As Unsigned Integer
    height As Unsigned Integer
    pitch As Unsigned Integer
    stride As Unsigned Integer

    fillbuffer As Sub CDecl (ByVal xoffset As Integer, ByVal yoffset As Integer, ByVal width As Integer, ByVal height As Integer, ByVal r As  Byte, ByVal g As Byte, ByVal b As Byte, ByVal a As Byte, ByVal dest As GLbuffer Ptr)
    writebuffer As Sub CDecl (ByVal xoffset As Integer, ByVal yoffset As Integer, ByVal width As Integer, ByVal height As Integer, ByVal fmt As Integer, ByVal type As Integer, ByVal pixels As Byte Ptr, ByVal dest As GLbuffer Ptr)
End Type

extern _gl_framebuffer Alias "_gl_framebuffer" As GLbuffer Ptr
extern _gl_backbuffer Alias "_gl_backbuffer" As GLbuffer Ptr
extern _gl_currentbuffer Alias "_gl_currentbuffer" As GLbuffer Ptr

'extern GLubyte _gl_clear_r, _gl_clear_g, _gl_clear_b, _gl_clear_a;
'
'extern GLint _gl_cutoff_n, _gl_cutoff_e, _gl_cutoff_s, _gl_cutoff_w;
'extern GLint _gl_scissor_n, _gl_scissor_e, _gl_scissor_s, _gl_scissor_w;
'extern GLubyte _gl_scissor_en;

Declare Sub _gl_setoutput CDecl Alias "_gl_setoutput"(ByVal buffer As Byte Ptr, ByVal w As Integer, ByVal h As Integer, ByVal pitch As Integer)

Declare Sub _gl_writebuffer_b8g8r8x8 CDecl Alias "_gl_writebuffer_b8g8r8x8" (ByVal x As Integer, ByVal y As Integer, ByVal w As Integer, ByVal h As Integer, ByVal fmt As Integer, ByVal type As Integer, ByVal pixels As Byte Ptr, ByVal dest As GLBuffer Ptr)
Declare Sub _gl_writebuffer_r8g8b8x8 CDecl Alias "_gl_writebuffer_r8g8b8x8" (ByVal x As Integer, ByVal y As Integer, ByVal w As Integer, ByVal h As Integer, ByVal fmt As Integer, ByVal type As Integer, ByVal pixels As Byte Ptr, ByVal dest As GLBuffer Ptr)
Declare Sub _gl_writebuffer_b8g8r8 CDecl Alias "_gl_writebuffer_b8g8r8" (ByVal x As Integer, ByVal y As Integer, ByVal w As Integer, ByVal h As Integer, ByVal fmt As Integer, ByVal type As Integer, ByVal pixels As Byte Ptr, ByVal dest As GLBuffer Ptr)
Declare Sub _gl_writebuffer_r8g8b8 CDecl Alias "_gl_writebuffer_r8g8b8" (ByVal x As Integer, ByVal y As Integer, ByVal w As Integer, ByVal h As Integer, ByVal fmt As Integer, ByVal type As Integer, ByVal pixels As Byte Ptr, ByVal dest As GLBuffer Ptr)
Declare Sub _gl_writebuffer_b5g6r5 CDecl Alias "_gl_writebuffer_b5g6r5" (ByVal x As Integer, ByVal y As Integer, ByVal w As Integer, ByVal h As Integer, ByVal fmt As Integer, ByVal type As Integer, ByVal pixels As Byte Ptr, ByVal dest As GLBuffer Ptr)
Declare Sub _gl_writebuffer_r5g6b5 CDecl Alias "_gl_writebuffer_r5g6b5" (ByVal x As Integer, ByVal y As Integer, ByVal w As Integer, ByVal h As Integer, ByVal fmt As Integer, ByVal type As Integer, ByVal pixels As Byte Ptr, ByVal dest As GLBuffer Ptr)
Declare Sub _gl_writebuffer_b5g5r5 CDecl Alias "_gl_writebuffer_b5g5r5" (ByVal x As Integer, ByVal y As Integer, ByVal w As Integer, ByVal h As Integer, ByVal fmt As Integer, ByVal type As Integer, ByVal pixels As Byte Ptr, ByVal dest As GLBuffer Ptr)
Declare Sub _gl_writebuffer_i8 CDecl Alias "_gl_writebuffer_i8" (ByVal x As Integer, ByVal y As Integer, ByVal w As Integer, ByVal h As Integer, ByVal fmt As Integer, ByVal type As Integer, ByVal pixels As Byte Ptr, ByVal dest As GLBuffer Ptr)

Declare Sub _gl_fillbuffer_b8g8r8a8 CDecl Alias "_gl_fillbuffer_b8g8r8a8" (ByVal x As Integer, ByVal y As Integer, ByVal w As Integer, ByVal h As Integer, ByVal r As Byte, ByVal g As Byte, ByVal b As Byte, ByVal a As Byte, ByVal dest As GLBuffer Ptr)
Declare Sub _gl_fillbuffer_r8g8b8a8 CDecl Alias "_gl_fillbuffer_r8g8b8a8" (ByVal x As Integer, ByVal y As Integer, ByVal w As Integer, ByVal h As Integer, ByVal r As Byte, ByVal g As Byte, ByVal b As Byte, ByVal a As Byte, ByVal dest As GLBuffer Ptr)
Declare Sub _gl_fillbuffer_b8g8r8 CDecl Alias "_gl_fillbuffer_b8g8r8" (ByVal x As Integer, ByVal y As Integer, ByVal w As Integer, ByVal h As Integer, ByVal r As Byte, ByVal g As Byte, ByVal b As Byte, ByVal a As Byte, ByVal dest As GLBuffer Ptr)
Declare Sub _gl_fillbuffer_r8g8b8 CDecl Alias "_gl_fillbuffer_r8g8b8" (ByVal x As Integer, ByVal y As Integer, ByVal w As Integer, ByVal h As Integer, ByVal r As Byte, ByVal g As Byte, ByVal b As Byte, ByVal a As Byte, ByVal dest As GLBuffer Ptr)
Declare Sub _gl_fillbuffer_b5g6r5 CDecl Alias "_gl_fillbuffer_b5g6r5" (ByVal x As Integer, ByVal y As Integer, ByVal w As Integer, ByVal h As Integer, ByVal r As Byte, ByVal g As Byte, ByVal b As Byte, ByVal a As Byte, ByVal dest As GLBuffer Ptr)
Declare Sub _gl_fillbuffer_r5g6b5 CDecl Alias "_gl_fillbuffer_r5g6b5" (ByVal x As Integer, ByVal y As Integer, ByVal w As Integer, ByVal h As Integer, ByVal r As Byte, ByVal g As Byte, ByVal b As Byte, ByVal a As Byte, ByVal dest As GLBuffer Ptr)
Declare Sub _gl_fillbuffer_b5g5r5 CDecl Alias "_gl_fillbuffer_b5g5r5" (ByVal x As Integer, ByVal y As Integer, ByVal w As Integer, ByVal h As Integer, ByVal r As Byte, ByVal g As Byte, ByVal b As Byte, ByVal a As Byte, ByVal dest As GLBuffer Ptr)
Declare Sub _gl_fillbuffer_i8 CDecl Alias "_gl_fillbuffer_i8" (ByVal x As Integer, ByVal y As Integer, ByVal w As Integer, ByVal h As Integer, ByVal r As Byte, ByVal g As Byte, ByVal b As Byte, ByVal a As Byte, ByVal dest As GLBuffer Ptr)

#endif 
