' Summary: pci.bi
' The FreeBasic include for the PCI manager
'
' Author:
'     Marcel Sondaar
'
' License:
'     <Public Domain>
'

' todo: documentation


' Enumeration: PCICALLS
' This enumeration lists all the defined calls to a PCI configuration 
' manager
'
' Derived from: none
'
' Derivatives: none
'
Enum PCICALLS

    ' Constant: PCI_GETDEVICE
    ' Get the Vendor/Type for a certain device
    '
    ' The device is numbered for each possible pci device. That means
    ' PCI function goes in increments of 1, Slots in increments of 8 and
    ' buses in increments of 256
    PCI_GETDEVICE = 0

    ' Constant: PCI_READDWORD
    ' Read a 32-bit doubleword from PCI Configuration space
    PCI_READDWORD = 1

    ' Constant: PCI_READBYTE
    ' Read one byte from PCI Configuration space
    PCI_READBYTE = 2

    ' Constant: PCI_WRITEDWORD
    PCI_WRITEDWORD = 3
    
    ' Constant: PCI_WRITEBYTE
    PCI_WRITEBYTE = 4

    ' Constant: PCI_GETBARTYPE
    PCI_GETBARTYPE = 5
    
    ' Constant: PCI_GETBARBASE
    PCI_GETBARBASE = 6

    ' Constant: PCI_ENUMERATEDEV
    PCI_ENUMERATEDEV = 7

    ' Constant: PCI_SETBARBASE
    PCI_SETBARBASE = 8
End Enum