;
; Summary: tas.asm
; *test-and-set for x86*
;
; Author:
;     Marcel Sondaar
;
; License:
;     Public Domain
;

SECTION .text

global TaS

;
; Function: TaS
; sets a bit in a byte, and return the original
;
; in:
;     - Stack(1) = address of the bit to access
;
; out:
;     Return = original bit's value (0 if clear, nonzero if set)
;

TaS:        MOV EDX, [ESP+1*4]      ; DX = stack(1)
            LOCK BTS word [EDX], 0
            SBB EAX, EAX
            RET
            