/*
    Summary: _Exit.c
    *The libc implementation*

    Author:
        Martin 'Solar' Baute

    License:
        Public Domain
*/

/* _Exit( int )

   This file is part of the Public Domain C Library (PDCLib).
   Permission is granted to use, modify, and / or redistribute at will.
*/

#include <stdlib.h>
#include <stdio.h>

#ifndef REGTEST
#include <_PDCLIB_glue.h>

/* Function: _Exit
   exits the program with a given status code, without running atexit scripts */

void _Exit( int status )
{
    /* TODO: Flush and close open streams. Remove tmpfile() files. */
    _PDCLIB_Exit( status );
}

#endif

#ifdef TEST
#include <_PDCLIB_test.h>

int main()
{
    BEGIN_TESTS;
    /* TODO: Add testdrivers after flush / close / tmpfile is implemented. */
    return TEST_RESULTS;
}

#endif
