/* Summary: glcullface.c
 * Implements the glCullFace function
 *
 * Author:
 *     Marcel Sondaar
 *
 * License:
 *     <Public Domain>
 */

#include <GL/gl.h>
#include <swgl/glpipe.h>

GLint _gl_cull_sign = -1, _gl_cull_enable = 0;

void glCullFace(GLenum mode)
{
    switch(mode)
    {
        case GL_FRONT:
            _gl_cull_sign = 1;
            break;
        case GL_BACK:
            _gl_cull_sign = -1;
            break;
        case GL_FRONT_AND_BACK:
            _gl_cull_sign = 0;
            break;
			
		default:
			/* todo: invalid argument */
			return;
    }
}
