
#include "words.bi"
#include "GL/gl.bi"

Declare Sub WordsLoad

Dim Shared Words_srcs() As String
Dim Shared Words_dsts() As String
Dim Shared Words_hint() As String
Dim Shared Words_shuffle() As Integer
Dim Shared Words_rating() As Integer
Dim Shared Words_count As Integer
Dim Shared Words_round As Integer
Dim Shared Words_roundrating As Integer

Declare Function MBChr(ByVal char As Integer) As String
Declare Function ReadLine(ByVal X As Integer, ByVal Y As Integer, ByVal colour As Integer) As String

Sub WordsPerformShuffle
    Dim lp As Integer
    ReDim Words_shuffle(Words_count) 
    ReDim Words_rating(Words_count)
    For lp = 0 to Words_count - 1
	Words_shuffle(lp) = lp
	Words_rating(lp) = -3
    Next lp
'    Dim temp As Integer, swappos As Integer
'    For lp = 1 to Words_count 
'	swappos = CInt(Rnd * Words_count) + 1
'	temp = Words_shuffle(lp)
'	Words_shuffle(lp) = Words_shuffle(swappos)
'	Words_shuffle(swappos) = temp
'    Next lp
End Sub

Sub WordsMain

    Dim f As Single
    Dim lp As Integer, lp2 As Integer
    Dim s As String

    WordsLoad
    WordsPerformShuffle    

    'While 1 = 1
    '    ReadKey
'
'	f = f + 0.1
'	If f > 0.5 Then f = 0
    'glClearColor 0, 0, f, 0
    'glClear GL_COLOR_BUFFER_BIT

    DrawMBString "Hello Unicode G: " + MBChr(&H03A9) + " B: " + MBChr(&H2505) + " H: " + MBChr(&H3041) , 8, 8, &HFFFFFFFF

    For lp = 1 to Words_count
        'DrawMBString Words_srcs(lp), 8, 10 * lp + 24, &HFFFFFF
        'DrawMBString Words_dsts(lp), 160, 10 * lp + 24, &HFFFFFF
    Next lp
  
    ReadKey

    Dim min As Integer, count As Integer, index As Integer
    min = 0
    While min < 3
        min = Words_rating(0)
	count = 0
        For lp = 0 to Words_count - 1
            If Words_rating(lp) < min Then 
	        min = Words_rating(lp)
		count = 1
	    ElseIf Words_rating(lp) = min Then
	        count = count + 1
            End If
	Next lp

	For lp = 1 to count
            lp2 = (Rnd * count)
            index = lp2
	    While Words_rating(index) <> min
               index = (index + 1) Mod Words_count
	    Wend	    

            f = f + 0.1
	    If f > 0.5 Then f = 0
            glClearColor 0, 0, f, 0
	    glClear GL_COLOR_BUFFER_BIT
	    DrawMBString "Original: (" + Str$(min) + ", " + Str$(count) + ", " + Str$(lp2) + ", " + Str$(index) + ")", 8, 8, &HFFFFFF
	    DrawMBString Words_srcs(index), 8, 17, &HFFFFFF
	    DrawMBString "Translation:", 8, 32, &HFFFFFF
            s = ReadLine(8, 41, &HFFFFFF)

            If s = Words_dsts(index) Then
                Words_rating(index) = Words_rating(index) + 1
            Else
	        Words_rating(index) = Words_rating(index) - 1
                DrawMBString "Correct answer:", 8, 56, &HFFFFFF
		DrawMBString Words_dsts(index), 8, 65, &HFFFFFF
                ReadKey
	    End If

	Next lp
        
	's = ReadLine(8, 16, &HFFFFFF)
  
    Wend

    glClearColor 0, 0.75, 0, 0
    glClear GL_COLOR_BUFFER_BIT
    DrawMBString "Done!", 8, 8, &HFFFFFF

End Sub

Function ReadLine(ByVal X As Integer, ByVal Y As Integer, ByVal colour As Integer) As String
    Dim result As String
    Dim scan As Integer
    Dim hpos As Integer
    hpos = 0
    Do
	scan = ReadKey
	If scan >= 32 Then
            result = result + chr$(scan)
	    DrawCharacterUnicode scan, X + 8 * hpos, Y, colour
	    hpos = hpos + 1
	ElseIf scan = 13 Then
        ElseIf scan = 8 And hpos > 0 Then
            hpos = hpos - 1
	    DrawCharacterUnicode 32, X + hpos * 8, Y, colour
	    result = Left$(result, hpos)
	End If
    Loop Until scan = 13
    Function = result

End Function

Function MBChr(ByVal char As Integer) As String
    Dim tmp As String
    tmp = ""
    If (char < &H80) Then
	tmp = Chr$(char)
    Else
        While char > &H7F
	    If tmp = "" Then
                tmp = chr$(char And &H7F)
	    Else	    
                tmp = chr$((char And &H7F) Or &H80) + tmp
	    End If
	    char = char SHR 7
	Wend
	tmp = chr$(char Or &H80) + tmp
    End If
    Function = tmp
End Function

Sub WordsLoadHiragana
    Words_count = 84
    Redim Words_srcs(84)
    Redim Words_dsts(84)
    Redim Words_hint(84)

    Words_srcs(0) = MBChr(&H3041): Words_dsts(0) = "A"
    Words_srcs(1) = MBChr(&H3042): Words_dsts(1) = "A"
    Words_srcs(2) = MBChr(&H3043): Words_dsts(2) = "I"
    Words_srcs(3) = MBChr(&H3044): Words_dsts(3) = "I"
    Words_srcs(4) = MBChr(&H3045): Words_dsts(4) = "U"
    Words_srcs(5) = MBChr(&H3046): Words_dsts(5) = "U"
    Words_srcs(6) = MBChr(&H3047): Words_dsts(6) = "E"
    Words_srcs(7) = MBChr(&H3048): Words_dsts(7) = "E"
    Words_srcs(8) = MBChr(&H3049): Words_dsts(8) = "O"
    Words_srcs(9) = MBChr(&H304A): Words_dsts(9) = "O"
    Words_srcs(10)= MBChr(&H304B): Words_dsts(10)= "KA"
    Words_srcs(11)= MBChr(&H304C): Words_dsts(11)= "GA"
    Words_srcs(12)= MBChr(&H304D): Words_dsts(12)= "KI"
    Words_srcs(13)= MBChr(&H304E): Words_dsts(13)= "GI"
    Words_srcs(14)= MBChr(&H304F): Words_dsts(14)= "KU"
    Words_srcs(15)= MBChr(&H3050): Words_dsts(15)= "GU"
    Words_srcs(16)= MBChr(&H3051): Words_dsts(16)= "KE"
    Words_srcs(17)= MBChr(&H3052): Words_dsts(17)= "GE"
    Words_srcs(18)= MBChr(&H3053): Words_dsts(18)= "KO"
    Words_srcs(19)= MBChr(&H3054): Words_dsts(19)= "GO"
    Words_srcs(20)= MBChr(&H3055): Words_dsts(20)= "SA"
    Words_srcs(21)= MBChr(&H3056): Words_dsts(21)= "ZA"
    Words_srcs(22)= MBChr(&H3057): Words_dsts(22)= "SHI"
    Words_srcs(23)= MBChr(&H3058): Words_dsts(23)= "ZI"
    Words_srcs(24)= MBChr(&H3059): Words_dsts(24)= "SU"
    Words_srcs(25)= MBChr(&H305A): Words_dsts(25)= "ZU"
    Words_srcs(26)= MBChr(&H305B): Words_dsts(26)= "SE"
    Words_srcs(27)= MBChr(&H305C): Words_dsts(27)= "ZE"
    Words_srcs(28)= MBChr(&H305D): Words_dsts(28)= "SO"
    Words_srcs(29)= MBChr(&H305E): Words_dsts(29)= "ZO"
    Words_srcs(30)= MBChr(&H305F): Words_dsts(30)= "TA"
    Words_srcs(31)= MBChr(&H3060): Words_dsts(31)= "DA"
    Words_srcs(32)= MBChr(&H3061): Words_dsts(32)= "CHI"
    Words_srcs(33)= MBChr(&H3062): Words_dsts(33)= "DI"
    Words_srcs(34)= MBChr(&H3063): Words_dsts(34)= "TSU"
    Words_srcs(35)= MBChr(&H3064): Words_dsts(35)= "TSU"
    Words_srcs(36)= MBChr(&H3065): Words_dsts(36)= "DU"
    Words_srcs(37)= MBChr(&H3066): Words_dsts(37)= "TE"
    Words_srcs(38)= MBChr(&H3067): Words_dsts(38)= "DE"
    Words_srcs(39)= MBChr(&H3068): Words_dsts(39)= "TO"
    Words_srcs(40)= MBChr(&H3069): Words_dsts(40)= "DO"
    Words_srcs(41)= MBChr(&H306A): Words_dsts(41)= "NA"
    Words_srcs(42)= MBChr(&H306B): Words_dsts(42)= "NI"
    Words_srcs(43)= MBChr(&H306C): Words_dsts(43)= "NU"
    Words_srcs(44)= MBChr(&H306D): Words_dsts(44)= "NE"
    Words_srcs(45)= MBChr(&H306E): Words_dsts(45)= "NO"
    Words_srcs(46)= MBChr(&H306F): Words_dsts(46)= "HA"
    Words_srcs(47)= MBChr(&H3070): Words_dsts(47)= "BA"
    Words_srcs(48)= MBChr(&H3071): Words_dsts(48)= "PA"
    Words_srcs(49)= MBChr(&H3072): Words_dsts(49)= "HI"
    Words_srcs(50)= MBChr(&H3073): Words_dsts(50)= "BI"
    Words_srcs(51)= MBChr(&H3074): Words_dsts(51)= "PI"
    Words_srcs(52)= MBChr(&H3075): Words_dsts(52)= "HU"
    Words_srcs(53)= MBChr(&H3076): Words_dsts(53)= "BU"
    Words_srcs(54)= MBChr(&H3077): Words_dsts(54)= "PU"
    Words_srcs(55)= MBChr(&H3078): Words_dsts(55)= "HE"
    Words_srcs(56)= MBChr(&H3079): Words_dsts(56)= "BE"
    Words_srcs(57)= MBChr(&H307A): Words_dsts(57)= "PE"
    Words_srcs(58)= MBChr(&H307B): Words_dsts(58)= "HO"
    Words_srcs(59)= MBChr(&H307C): Words_dsts(59)= "BO"
    Words_srcs(60)= MBChr(&H307D): Words_dsts(60)= "PO"
    Words_srcs(61)= MBChr(&H307E): Words_dsts(61)= "MA"
    Words_srcs(62)= MBChr(&H307F): Words_dsts(62)= "MI"
    Words_srcs(63)= MBChr(&H3080): Words_dsts(63)= "MU"
    Words_srcs(64)= MBChr(&H3081): Words_dsts(64)= "ME"
    Words_srcs(65)= MBChr(&H3082): Words_dsts(65)= "MO"
    Words_srcs(66)= MBChr(&H3083): Words_dsts(66)= "YA"
    Words_srcs(67)= MBChr(&H3084): Words_dsts(67)= "YA"
    Words_srcs(68)= MBChr(&H3085): Words_dsts(68)= "YU"
    Words_srcs(69)= MBChr(&H3086): Words_dsts(69)= "YU"
    Words_srcs(70)= MBChr(&H3087): Words_dsts(70)= "YO"
    Words_srcs(71)= MBChr(&H3088): Words_dsts(71)= "YO"
    Words_srcs(72)= MBChr(&H3089): Words_dsts(72)= "RA"
    Words_srcs(73)= MBChr(&H308A): Words_dsts(73)= "RI"
    Words_srcs(74)= MBChr(&H308B): Words_dsts(74)= "RU"
    Words_srcs(75)= MBChr(&H308C): Words_dsts(75)= "RE"
    Words_srcs(76)= MBChr(&H308D): Words_dsts(76)= "RO"
    Words_srcs(77)= MBChr(&H308E): Words_dsts(77)= "WA"
    Words_srcs(78)= MBChr(&H308F): Words_dsts(78)= "WA"
    Words_srcs(79)= MBChr(&H3090): Words_dsts(79)= "WI"
    Words_srcs(80)= MBChr(&H3091): Words_dsts(80)= "WE"
    Words_srcs(81)= MBChr(&H3092): Words_dsts(81)= "WO"
    Words_srcs(82)= MBChr(&H3093): Words_dsts(82)= "N"
    Words_srcs(83)= MBChr(&H3094): Words_dsts(83)= "VU"
End Sub

Sub WordsLoad
    Words_count = 30
    Redim Words_srcs(30)
    Redim Words_dsts(30)
    Redim Words_hint(30)

    Words_srcs(0) = MBChr(&H4E00): Words_dsts(0) = "ONE"
    Words_srcs(1) = MBChr(&H4E8C): Words_dsts(1) = "TWO"
    Words_srcs(2) = MBChr(&H4E09): Words_dsts(2) = "THREE"
    Words_srcs(3) = MBChr(&H56DB): Words_dsts(3) = "FOUR"
    Words_srcs(4) = MBChr(&H4E94): Words_dsts(4) = "FIVE"
    Words_srcs(5) = MBChr(&H516D): Words_dsts(5) = "SIX"
    Words_srcs(6) = MBChr(&H4E03): Words_dsts(6) = "SEVEN"
    Words_srcs(7) = MBChr(&H516B): Words_dsts(7) = "EIGHT"
    Words_srcs(8) = MBChr(&H4E5D): Words_dsts(8) = "NINE"
    Words_srcs(9) = MBChr(&H5341): Words_dsts(9) = "TEN"
    Words_srcs(10)= MBChr(&H767E): Words_dsts(10)= "HUNDRED"
    Words_srcs(11)= MBChr(&H5343): Words_dsts(11)= "THOUSAND"
    Words_srcs(12)= MBChr(&H4E0A): Words_dsts(12)= "ABOVE"
    Words_srcs(13)= MBChr(&H4E0B): Words_dsts(13)= "BELOW"
    Words_srcs(14)= MBChr(&H5DE6): Words_dsts(14)= "LEFT"
    Words_srcs(15)= MBChr(&H53F3): Words_dsts(15)= "RIGHT"
    Words_srcs(16)= MBChr(&H4E2D): Words_dsts(16)= "MIDDLE"
    Words_srcs(17)= MBChr(&H5927): Words_dsts(17)= "LARGE"
    Words_srcs(18)= MBChr(&H5C0F): Words_dsts(18)= "SMALL"
    Words_srcs(19)= MBChr(&H6708): Words_dsts(19)= "MOON"
    Words_srcs(20)= MBChr(&H65E5): Words_dsts(20)= "SUN"
    Words_srcs(21)= MBChr(&H5E74): Words_dsts(21)= "YEAR"
    Words_srcs(22)= MBChr(&H65E9): Words_dsts(22)= "EARLY"
    Words_srcs(23)= MBChr(&H6728): Words_dsts(23)= "TREE"
    Words_srcs(24)= MBChr(&H6797): Words_dsts(24)= "WOODS"
    Words_srcs(25)= MBChr(&H5C71): Words_dsts(25)= "MOUNTAIN"
    Words_srcs(26)= MBChr(&H5DDD): Words_dsts(26)= "RIVER"
    Words_srcs(27)= MBChr(&H571F): Words_dsts(27)= "SOIL"
    Words_srcs(28)= MBChr(&H7A7A): Words_dsts(28)= "SKY"
    Words_srcs(29)= MBChr(&H7530): Words_dsts(29)= "RICE PADDY"
        
End Sub