' Summary: vdisk.bi
' Defines for all vdisk-internal functions
'
' Author:
'     Marcel Sondaar
'
' License:
'     <Public Domain>
'

#include "mcobject.bi"

Declare Sub ErrorString(ByRef text As String)

Declare Function VDisk_Command_C CDecl Alias "VDisk_Command_C" (ByVal cmd As Unsigned Byte Ptr) As Integer
Declare Function VDisk_Command CDecl Alias "VDisk_Command" (ByRef cmd As String) As Integer

Type VDISK_STORAGE Extends MCObject
    mMapIndex As Integer
    mMapReferences As Integer
    mSize As Unsigned Long
    mAlias As String * 16
    ReadFunc As Function(ByVal Offset As Unsigned Long, ByVal Size As Unsigned Long, ByVal Dest As Byte Ptr) As Integer
    WriteFunc As Function(Offset As Unsigned Long, ByVal Size As Unsigned Long, ByVal Src As Byte Ptr) As Integer    
End Type

Declare Function VDisk_HostFile_Size Alias "VDisk_HostFile_Size" (ByVal cstr As Byte Ptr) As Unsigned Integer
Declare Function VDisk_HostFile_Handle Alias "VDisk_HostFile_Handle" (ByVal cstr As Byte Ptr) As Byte Ptr
Declare Sub VDisk_HostFile_Close Alias "VDisk_HostFile_Close" (ByVal handle As Byte Ptr)
Declare Function VDisk_HostFile_Write Alias "VDisk_HostFile_Write" (ByVal handle As Byte Ptr, ByVal Offset As Integer, ByVal Size As Integer, ByVal content As Byte Ptr) As Integer
Declare Function VDisk_HostFile_Read Alias "VDisk_HostFile_Read" (ByVal handle As Byte Ptr, ByVal Offset As Integer, ByVal Size As Integer, ByVal content As Byte Ptr) As Integer

Declare Function VDisk_StorageCreateFromFile CDecl Alias "VDisk_StorageCreateFromFile" (ByRef filename As String, ByRef ref As String) As Integer

