;
; Summary: swblit.v
;
; Custom verite firmware capable of performing on-device blitting
;
; Author:
;     Marcel Sondaar
;
; License:
;     <Public Domain>
;

ORG 0

DB 0x34, 0x40, 0x0D, 0x21 ; flush garbage from fifo (wtf?)

dest2:

DB 0x34, 0x4A, 0x0D, 0x21 ; rfifo 0x4D, one, swapped (offset)
DB 0x34, 0x41, 0x0D, 0x21 ; rfifo 0x41, one, swapped (width)
DB 0x34, 0x42, 0x0D, 0x21 ; (height)
DB 0x34, 0x4C, 0x0D, 0x21 ; (color)

DB 0x76, 0x45, 0, 15 * 4 ; dest1
DB 0x76, 0x4D, 0, 14 * 4 ; dest1 - dest2
DB 0x11, 0x46, 0x00, 0x4D ; negate, r46 = dest2 - dest1

DB 0x10, 0x4B, 0x00, 0x4A ; copy dest

DB 0x01, 0x43, 0x41, 0x01 ; r43 = r41 - 1
loopback:
DB 0x47, 0x44, 0x43, 16   ; SHRI r44, r43, 16
DB 0x12, 0x48, 0x44, 0x46 ; AND r44, r44, dest2-dest1
DB 0x10, 0x47, 0x48, 0x45 ; ADD r47, r48, dest1
DB 0x6F, 0,    0,    0x47 ; jmpr r44
DB 0x00, 0x4F, 0x4B, 0x00 ; r4f = tmpdest (and jump)
dest1:
DB 0x7A, 0,    0x4C, 0x4F ; stw [r4F], color
DB 0x00, 0x4B, 0x4B, 0x04 ; ADDI 0x4B, 0x4B, 4, next pixel
DB 0x6c, 0x00, 0x00, 10  ; jmp loopback
DB 0x01, 0x43, 0x43, 1
