' Summary: scheduler.bi
' Header file for I/O Schedulers
'
' Author:
'     Marcel Sondaar
'
' License:
'     <Public Domain>
'

Type Request
    block As Integer
    numblocks As Integer
    requester As Integer
    priority As Integer
    direction As Integer
    sourceblock As Integer
    sourcemap As Integer
    custom As Byte Ptr
End Type

Type Scheduler
    AddRequest As Sub(ByVal privatedata as Byte Ptr Ptr, ByRef req As Request)
    PopRequest As Function(ByVal privatedata as Byte Ptr Ptr) As Request
    PopRequestSingle As Function(ByVal privatedata as Byte Ptr Ptr) As Request
    IsEmpty As Function(ByVal privatedata as Byte Ptr Ptr) As Integer
    Release As Sub(ByVal privatedata as Byte Ptr)
    privatedata As Byte Ptr
End Type

Declare Function SimpleSchedulerCreate() As Scheduler

' SimpleScheduler Functions
Declare Sub SimpleSchedulerRelease(ByVal privatedata as Byte Ptr)
Declare Sub SimpleSchedulerAddRequest(ByVal privatedata as Byte Ptr Ptr, ByRef req As Request)
Declare Function SimpleSchedulerPopRequest(ByVal privatedata as Byte Ptr Ptr) As Request
Declare Function SimpleSchedulerPopRequestSingle(ByVal privatedata as Byte Ptr Ptr) As Request
Declare Function SimpleSchedulerIsEmpty(ByVal privatedata as Byte Ptr Ptr) As Integer